module ZBUS_IF(
   lbus_clk,
   //# blk_rstn, blk_drdy, blk_dvld, blk_encdec,
   blk_rstn, blk_drdy, blk_dvld,
   latency_check, cycle_count, cycle_count_all,
   //blk_din,
   //blk_dout,
   clk, rst_n,
   //odata,
   load, fetch, init, ack, datain_read_addr, dataout_we, datain_re,
state, check_vld,
read_allow, data_size //#
);

input lbus_clk;
input blk_rstn;
input blk_drdy;
output blk_dvld;
//# input blk_encdec;
//input [511:0] blk_din;

//output [255:0] blk_dout;
output clk;
output rst_n;
//output [15:0] idata;
//input [15:0] odata;
output load;
output fetch;
input ack;
output init;
output [15:0] datain_read_addr;
output datain_re;
output dataout_we;

input read_allow; //#
input [7:0] data_size; //#

input latency_check;
output check_vld;


/******************* reg wire ****************/
//output 
output reg [2:0] state;              //state 00:base, 01:load, 10:fetch, 11:
reg [2:0] next_state;
//# reg [5:0] cnt;
reg [7:0] cnt;
// Add Kazuo
//# assign datain_read_addr = (state == 3'b010)?  {10'b0,1'b1,cnt[4:0]} :{11'b0,cnt[4:0]};
assign datain_read_addr = (state == 3'b010)?  {8'h0,1'b1,cnt[6:0]} :{9'b0,cnt[6:0]};

reg datain_re_r;
wire datain_re_w;
//clk & rst_n assignment 
assign clk = lbus_clk;
assign rst_n = blk_rstn;

assign check_vld = ((state == 3'b010) && (cnt == 8'hf) && ack)? 1:0; 
//reg
//reg [255:0] blk_dout_r;
//assign blk_dout = blk_dout_r;


//wire
//reg [15:0] idata_r;
//assign idata = idata_r;

// Add Kazuo
//reg dataout_we_r;
//assign dataout_we = dataout_we_r;
assign dataout_we = ((state == 3'b010) && ack)? 1:0;
//reg datain_re_r;
//assign datain_re = datain_re_r;
//assign datain_re = ((state == 3'b01) && blk_drdy)? 1:0;
assign datain_re = datain_re_r;
assign datain_re_w = (((state == 3'b001) && ack) || blk_drdy || (state == 3'b011))? 1:0;
always @(posedge clk or negedge rst_n)begin
   if (~rst_n) datain_re_r <= 0;
   else datain_re_r <= datain_re_w;
end

reg fetch_r;
//# reg load_r;


//init
//assign init = ((state == 3'b000) && blk_drdy)? 1:0; 
assign init = ((state == 3'b000) && blk_drdy)? 1:0; 

//blk_dvld
assign blk_dvld = ((state == 3'b010) && (cnt == 8'h0f) && ack)? 1:0;

//fetch signal 
//assign fetch = (state == 2'b10)? 1:0;
assign fetch = fetch_r;
always @(posedge clk or negedge rst_n) begin
   if (~rst_n) fetch_r <= 0;
   else begin               
      if (state == 3'b010) begin
         if ((ack) && (cnt == 8'hf)) fetch_r <= 0;
         else fetch_r <= 1; 
      end                   
      else fetch_r <= 0;    
   end                      
end                         
                            
//load signal               
//assign load = load_r;       
reg load_r;
assign load = load_r;
always @(posedge clk or negedge rst_n) begin
   if (~rst_n) load_r <=0;  
   else if (state == 3'b001) begin
      if (ack && (cnt == data_size)) load_r <= 0;
      else load_r <= 1;
   end
   else load_r <= 0;
end

//latency check(Hash Core)
output reg [15:0] cycle_count;
always @(posedge clk or negedge rst_n) begin
   if (~rst_n) cycle_count <= 16'h0;
   else if (state == 3'b010) begin
      if (cnt == 0) cycle_count <= cycle_count + 1;
      else cycle_count <= cycle_count;
   end
   else cycle_count <= cycle_count;
end


//latency check(Hash FPGA)
output reg [15:0] cycle_count_all;
wire count_it;
assign count_it = ((state == 3'b000) || (state == 3'b110))? 1'b0 : 1'b1;
always @(posedge clk or negedge rst_n) begin
   if (~rst_n) cycle_count_all <= 16'h0;
   else if (count_it) cycle_count_all <= cycle_count_all + 'h1;
   else cycle_count_all <= cycle_count_all;
end

//data count
always @(posedge clk or negedge rst_n) begin
   if (~rst_n) cnt <= 8'h0;
   else begin
      if (state == 3'b111) cnt <= cnt +1;
      else if (state == 3'b001) begin
         if ((cnt == data_size) && ack) cnt <= 0;
         //else if (blk_encdec && (cnt == 5'h10) && ack) cnt <= 0;
         else if (ack) cnt <= cnt + 1;
         else cnt <= cnt;
      end
      else if (state == 3'b010) begin
         if ((cnt == 8'hf) && ack) cnt <= 0;
         else if (ack) cnt <= cnt + 1;
         else cnt <= cnt;
      end
      //else if (blk_drdy) cnt <= cnt+1; 
      else cnt <= cnt;
   end
end

always @(posedge clk or negedge rst_n)begin
	if (~rst_n) state <= 3'b0;
	else state <= next_state;
end

//always @(blk_drdy or ack or cnt or state or blk_encdec or read_allow) begin
always @(blk_drdy or ack or cnt or latency_check or state or data_size or read_allow) begin
      case(state) 
         3'b000    :  begin
            if (blk_drdy) next_state <= 3'b111;
            else next_state <= 3'b000;
         end
         3'b111    :  next_state <= 3'b011;
         3'b011    :  next_state <= 3'b001;
         3'b001    :  begin
            if (ack) begin
              //# if ((cnt == 6'h10) && blk_encdec) next_state <= 3'b110; //#
              //# else if (cnt == 6'h20) next_state <= 3'b110; //#
                 if (cnt == data_size) begin
                    if (latency_check) next_state <= 3'b010;
                    else next_state <= 3'b110; //#
                 end
                 else next_state <= 3'b001;
              end
              else next_state <= 3'b001;
           end

         //#
         3'b110    :  begin
            if (read_allow) next_state <= 3'b010;
            else if (blk_drdy) next_state <= 3'b111;
            else next_state <= 3'b110;
         end

         3'b010    :  begin
            if ((cnt == 6'hf) && ack) next_state <= 3'b000;
            else next_state <= 3'b010;
         end

         default  :  next_state <= 3'b000;
      endcase
end

endmodule
//61 62 63 80 00 00 00 00 00 00 00 00 00 00 00 00 
//00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
//00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
//00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 18
